#include <optix_world.h>
struct BiDirSubPathVertex {bool existing;};
using namespace optix;

rtCallableProgram(void, sampleLightPath, ());
rtCallableProgram(void, sampleEye, ());
rtDeclareVariable(uint2,         launch_index, rtLaunchIndex, );
rtBuffer<float4, 2>              output_buffer;
RT_CALLABLE_PROGRAM void sampleLightPath_f() {}
RT_CALLABLE_PROGRAM void sampleEye_f() {}

RT_PROGRAM void pathtrace_camera() {
    BiDirSubPathVertex lightVertices[2];
    lightVertices[0].existing = false;
    lightVertices[1].existing = false;

    for(unsigned int i=0; i<2; i++) {
        sampleLightPath();
        if(!(lightVertices[i].existing)) break;
    }
//    rtPrintf("czteryn");
    sampleEye();

    output_buffer[launch_index] = make_float4(1.f, 1.f, 1.f, 1.f);
}

RT_PROGRAM void exception()
{
    rtPrintExceptionDetails();
    output_buffer[launch_index] = make_float4(1.f, 1.f, 0.f, 0.0f);
}
